package java.lang;

import java.io.DataInputStream;
import java.util.zip.InflaterInputStream;
import java.security.AccessController;
import java.security.PrivilegedAction;
import java.io.InputStream;
import java.lang.ref.SoftReference;

class CharacterName
{
    private static SoftReference<byte[]> refStrPool;
    private static int[][] lookup;
    
    CharacterName() {
    }
    
    private static synchronized byte[] initNamePool() {
        byte[] array = null;
        if (CharacterName.refStrPool != null && (array = (byte[])CharacterName.refStrPool.get()) != null) {
            return array;
        }
        Object o = null;
        try {
            o = new DataInputStream(new InflaterInputStream((InputStream)AccessController.doPrivileged(new PrivilegedAction<InputStream>() {
                @Override
                public InputStream run() {
                    return this.getClass().getResourceAsStream("uniName.dat");
                }
            })));
            CharacterName.lookup = new int[4352][];
            int int1 = o.readInt();
            int int2 = o.readInt();
            byte[] b = new byte[int2];
            o.readFully(b);
            int n = 0;
            int i = 0;
            int n2 = 0;
            do {
                int n3 = b[i++] & 0xFF;
                if (n3 == 0) {
                    n3 = (b[i++] & 0xFF);
                    n2 = ((b[i++] & 0xFF) << 16 | (b[i++] & 0xFF) << 8 | (b[i++] & 0xFF));
                }
                else {
                    ++n2;
                }
                int n4 = n2 >> 8;
                if (CharacterName.lookup[n4] == null) {
                    CharacterName.lookup[n4] = new int[256];
                }
                CharacterName.lookup[n4][n2 & 0xFF] = (n << 8 | n3);
                n += n3;
            } while (i < int2);
            array = new byte[int1 - int2];
            o.readFully(array);
            CharacterName.refStrPool = new SoftReference(array);
        }
        catch (Exception ex) {
            throw new InternalError(ex.getMessage(), ex);
        }
        finally {
            try {
                if (o != null) {
                    o.close();
                }
            }
            catch (Exception ex2) {}
        }
        return array;
    }
    
    public static String get(int n) {
        byte[] initNamePool;
        if (CharacterName.refStrPool == null || (initNamePool = (byte[])CharacterName.refStrPool.get()) == null) {
            initNamePool = initNamePool();
        }
        int n2;
        if (CharacterName.lookup[n >> 8] == null || (n2 = CharacterName.lookup[n >> 8][n & 0xFF]) == 0) {
            return null;
        }
        return new String(initNamePool, 0, n2 >>> 8, n2 & 0xFF);
    }
}
